<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <meta name="generator" content="pandoc">
  <meta name="author" content="Ondra Voves">
  <title>Testování a py.test</title>
  <meta name="apple-mobile-web-app-capable" content="yes">
  <meta name="apple-mobile-web-app-status-bar-style" content="black-translucent">
  <meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1.0, user-scalable=no, minimal-ui">
  <link rel="stylesheet" href="reveal.js/css/reveal.css">
  <style type="text/css">code{white-space: pre;}</style>
  <style type="text/css">
div.sourceCode { overflow-x: auto; }
table.sourceCode, tr.sourceCode, td.lineNumbers, td.sourceCode {
  margin: 0; padding: 0; vertical-align: baseline; border: none; }
table.sourceCode { width: 100%; line-height: 100%; }
td.lineNumbers { text-align: right; padding-right: 4px; padding-left: 4px; color: #aaaaaa; border-right: 1px solid #aaaaaa; }
td.sourceCode { padding-left: 5px; }
code > span.kw { color: #007020; font-weight: bold; } /* Keyword */
code > span.dt { color: #902000; } /* DataType */
code > span.dv { color: #40a070; } /* DecVal */
code > span.bn { color: #40a070; } /* BaseN */
code > span.fl { color: #40a070; } /* Float */
code > span.ch { color: #4070a0; } /* Char */
code > span.st { color: #4070a0; } /* String */
code > span.co { color: #60a0b0; font-style: italic; } /* Comment */
code > span.ot { color: #007020; } /* Other */
code > span.al { color: #ff0000; font-weight: bold; } /* Alert */
code > span.fu { color: #06287e; } /* Function */
code > span.er { color: #ff0000; font-weight: bold; } /* Error */
code > span.wa { color: #60a0b0; font-weight: bold; font-style: italic; } /* Warning */
code > span.cn { color: #880000; } /* Constant */
code > span.sc { color: #4070a0; } /* SpecialChar */
code > span.vs { color: #4070a0; } /* VerbatimString */
code > span.ss { color: #bb6688; } /* SpecialString */
code > span.im { } /* Import */
code > span.va { color: #19177c; } /* Variable */
code > span.cf { color: #007020; font-weight: bold; } /* ControlFlow */
code > span.op { color: #666666; } /* Operator */
code > span.bu { } /* BuiltIn */
code > span.ex { } /* Extension */
code > span.pp { color: #bc7a00; } /* Preprocessor */
code > span.at { color: #7d9029; } /* Attribute */
code > span.do { color: #ba2121; font-style: italic; } /* Documentation */
code > span.an { color: #60a0b0; font-weight: bold; font-style: italic; } /* Annotation */
code > span.cv { color: #60a0b0; font-weight: bold; font-style: italic; } /* CommentVar */
code > span.in { color: #60a0b0; font-weight: bold; font-style: italic; } /* Information */
  </style>
  <link rel="stylesheet" href="reveal.js/css/theme/blood.css" id="theme">
  <!-- Printing and PDF exports -->
  <script>
    var link = document.createElement( 'link' );
    link.rel = 'stylesheet';
    link.type = 'text/css';
    link.href = window.location.search.match( /print-pdf/gi ) ? 'reveal.js/css/print/pdf.css' : 'reveal.js/css/print/paper.css';
    document.getElementsByTagName( 'head' )[0].appendChild( link );
  </script>
  <!--[if lt IE 9]>
  <script src="reveal.js/lib/js/html5shiv.js"></script>
  <![endif]-->
</head>
<body>
  <div class="reveal">
    <div class="slides">

<section>
  <h1 class="title">Testování a py.test</h1>
  <p class="author">Ondra Voves</p>
</section>

<section><section id="proč-testovat" class="titleslide slide level1"><h1>Proč testovat?</h1></section><section id="bugy" class="slide level2">
<h2>BUGY</h2>
<ul>
<li class="fragment">Platí pravidlo: <strong>Čím dříve se na bug příjde tím menší škodu napáchá =&gt; tím méně stojí času a pěněz</strong></li>
</ul>
</section><section id="workflow" class="slide level2">
<h2>WORKFLOW</h2>
<ul>
<li class="fragment">Snadněji se <strong>refaktoruje</strong></li>
<li class="fragment">Snadněji se <strong>přidává funkcionalita</strong></li>
<li class="fragment">Programátor <strong>nemusí</strong> zkoumat a znát všechná zákoutí projektu =&gt; <strong>rychlejší</strong> zaučení nových členů + <strong>zkrácení</strong> vývojového cyklu</li>
<li class="fragment">Možnost pokročilejšího workflow (<strong>CI</strong>, <strong>CD</strong>)</li>
</ul>
</section><section id="continual-integration" class="slide level2">
<h2>Continual Integration</h2>
<ul>
<li class="fragment">Automaticka kontrola projektu jako celku
<ul>
<li class="fragment">Features se merguji do mastera kde se automaticky otestuje integrita změn</li>
</ul></li>
</ul>
</section><section id="continual-deploy" class="slide level2">
<h2>Continual Deploy</h2>
<ul>
<li class="fragment">Automatické nasazování (produkce, test)
<ul>
<li class="fragment">Merge do větve (<strong>production</strong>, <strong>test</strong>)
<ul>
<li class="fragment">Nasazeni na stroje (<strong>docker</strong>, <strong>fabric</strong>)</li>
</ul></li>
</ul></li>
</ul>
</section></section>
<section><section id="testování-v-pythonu" class="titleslide slide level1"><h1>Testování v Pythonu</h1></section><section id="výhody-testování-pythonem" class="slide level2">
<h2>Výhody testování pythonem</h2>
<ul>
<li class="fragment">Snadnější <strong>čtení</strong>, <strong>psaní</strong>, <strong>spouštění</strong></li>
<li class="fragment">Pamět a CPU <strong>nejsou</strong> bottleneck</li>
<li class="fragment">Nasazování <strong>není</strong> problém</li>
<li class="fragment"><strong>Nemusí</strong> se testovat jen python kód (C, Webovky, Monitoring, atp...)</li>
</ul>
</section></section>
<section><section id="py.test" class="titleslide slide level1"><h1>py.test</h1></section><section id="co-je-py.test" class="slide level2">
<h2>Co je py.test?</h2>
<ul>
<li class="fragment">Open source testovací framework <img src="https://img.shields.io/github/stars/pytest-dev/pytest.svg" alt="pytest_stars" /> <img src="https://img.shields.io/github/contributors/pytest-dev/pytest.svg" alt="pytest_contributors" /></li>
<li class="fragment">Aktivně se vyvíjí od roku 2007 a neustále se zlepšuje</li>
<li class="fragment">Není součást standartní knihovny, ale v komunitě je známý</li>
<li class="fragment"><p>Instalace:</p>
<div class="sourceCode"><pre class="sourceCode bash"><code class="sourceCode bash">$ <span class="ex">pip</span> install pytest
$ <span class="ex">pip3</span> install pytest</code></pre></div></li>
</ul>
</section><section id="proč-používát-py.test" class="slide level2">
<h2>Proč používát py.test</h2>
<ul>
<li class="fragment">Kompatibilní s <strong>unittest</strong> and <strong>nosetest</strong> (Aby se usnadníl přechod)</li>
<li class="fragment">Není tak komplikováný jak by se na první pohled mohlo zdát</li>
<li class="fragment">Pomáhá psát lepší testy =&gt; lepší kód =&gt; lepší software</li>
<li class="fragment">Dobrá dokumentace, Komunita</li>
<li class="fragment">Pokročilé funkce, pluginovatelnost (+150)</li>
<li class="fragment">Používá například <strong>Fedora</strong> a <strong>Mozilla</strong></li>
</ul>
</section></section>
<section><section id="první-test" class="titleslide slide level1"><h1>První test</h1></section><section id="ukázka" class="slide level2">
<h2>Ukázka</h2>
<div class="sourceCode"><pre class="sourceCode python"><code class="sourceCode python"><span class="kw">def</span> division(a, b):
    <span class="cf">return</span> a <span class="op">/</span> <span class="bu">float</span>(b)

<span class="kw">def</span> test_division():
    <span class="cf">assert</span> division(<span class="dv">1</span>, <span class="dv">1</span>) <span class="op">==</span> <span class="dv">1</span></code></pre></div>
</section><section id="spouštění" class="slide level2">
<h2>Spouštění</h2>
<div class="sourceCode"><pre class="sourceCode bash"><code class="sourceCode bash">$ <span class="ex">py.test</span> test_division.py</code></pre></div>
</section><section id="ok" class="slide level2">
<h2>OK</h2>
<figure>
<img src="img/divison_ok.png" />
</figure>
</section><section id="fail" class="slide level2">
<h2>Fail</h2>
<figure>
<img src="img/divison_error.png" />
</figure>
</section><section id="spouštění-testů-12" class="slide level2">
<h2>Spouštění testů (1/2)</h2>
<ul>
<li class="fragment"><p>V aktuálním adresáři rekurzivně projde složký <strong>test</strong>, <strong>tests</strong> a hledá soubory ve formatu <strong>test_*.py</strong></p>
<div class="sourceCode"><pre class="sourceCode bash"><code class="sourceCode bash">$ <span class="ex">py.test</span></code></pre></div></li>
<li class="fragment"><p>Všechny testy v souboru <strong>test_module.py</strong></p>
<div class="sourceCode"><pre class="sourceCode bash"><code class="sourceCode bash">$ <span class="ex">py.test</span> test_module.py </code></pre></div></li>
</ul>
</section><section id="spouštšní-testů-22" class="slide level2">
<h2>Spouštšní testů (2/2)</h2>
<ul>
<li class="fragment"><p>Test <strong>test_foo</strong> v souboru <strong>test_module.py</strong></p>
<div class="sourceCode"><pre class="sourceCode bash"><code class="sourceCode bash">$ <span class="ex">py.test</span> test_module.py::test_foo</code></pre></div></li>
<li class="fragment"><p>Všechny testy s keyword <strong>foo</strong> a bez <strong>bar</strong> v souboru <strong>test_module.py</strong></p>
<div class="sourceCode"><pre class="sourceCode bash"><code class="sourceCode bash">$ <span class="ex">py.test</span> test_module.py -k <span class="st">&quot;foo not bar&quot;</span></code></pre></div></li>
</ul>
</section></section>
<section><section id="skip" class="titleslide slide level1"><h1>Skip</h1></section><section id="skipování-testu" class="slide level2">
<h2>Skipování testu</h2>
<ul>
<li class="fragment">Jsou případy kdy cheme aby testy procházeli přesto že nějaký test padá</li>
</ul>
</section><section id="simple" class="slide level2">
<h2>Simple</h2>
<div class="sourceCode"><pre class="sourceCode python"><code class="sourceCode python"><span class="im">import</span> pytest

<span class="at">@pytest.mark.skipif</span>()
<span class="kw">def</span> test_skipped():
    <span class="cf">assert</span> <span class="dv">1</span></code></pre></div>
</section><section id="conditional" class="slide level2">
<h2>Conditional</h2>
<div class="sourceCode"><pre class="sourceCode python"><code class="sourceCode python"><span class="im">import</span> pytest
<span class="im">import</span> sys

<span class="at">@pytest.mark.skipif</span>(sys.version_info[<span class="dv">0</span>] <span class="op">==</span> <span class="dv">3</span>,
                    reason<span class="op">=</span><span class="st">&quot;Only Python 2&quot;</span>)
<span class="kw">def</span> test_skipped():
    <span class="cf">assert</span> <span class="dv">1</span></code></pre></div>
<figure>
<img src="img/skipif.png" />
</figure>
</section></section>
<section><section id="parametrizace-testu" class="titleslide slide level1"><h1>Parametrizace testu</h1></section><section id="ukázka-1" class="slide level2">
<h2>Ukázka</h2>
<div class="sourceCode"><pre class="sourceCode python"><code class="sourceCode python"><span class="im">import</span> pytest

<span class="kw">def</span> division(a, b):
    <span class="cf">return</span> a <span class="op">/</span> <span class="bu">float</span>(b)
    
<span class="at">@pytest.mark.parametrize</span>(<span class="st">&quot;a&quot;</span>, [<span class="dv">1</span>, <span class="dv">2</span>, <span class="dv">3</span>, <span class="dv">4</span>])
<span class="kw">def</span> test_division_param(a):
    <span class="cf">assert</span> division(a, <span class="dv">1</span>) <span class="op">==</span> a</code></pre></div>
<figure>
<img src="img/param.png" />
</figure>
</section></section>
<section><section id="značkování" class="titleslide slide level1"><h1>Značkování</h1></section><section id="o-co-jde" class="slide level2">
<h2>O co jde?</h2>
<ul>
<li class="fragment">Každy test se da označit libovolným textem/značkou</li>
<li class="fragment">Skupina testů</li>
<li class="fragment">Abstraktnější organizace testu (pomale testy, readonly, db testy)</li>
</ul>
</section><section id="ukázka-12" class="slide level2">
<h2>Ukázka (1/2)</h2>
<div class="sourceCode"><pre class="sourceCode python"><code class="sourceCode python"><span class="im">import</span> pytest
<span class="im">import</span> time


<span class="at">@pytest.mark.slowtest</span>
<span class="kw">def</span> test_slow():
    time.sleep(<span class="dv">1</span>)
    <span class="cf">assert</span> <span class="va">True</span>


<span class="kw">def</span> test_fast():
    <span class="cf">assert</span> <span class="va">True</span></code></pre></div>
</section><section id="ukázka-22" class="slide level2">
<h2>Ukázka (2/2)</h2>
<figure>
<img src="img/mark.png" />
</figure>
<figure>
<img src="img/mark_slowtest.png" />
</figure>
</section></section>
<section><section id="fixtures" class="titleslide slide level1"><h1>Fixtures</h1></section><section id="co-jsou-fixtures" class="slide level2">
<h2>Co jsou fixtures</h2>
<ul>
<li class="fragment">Testovací kontext (<strong>Test setup</strong>, <strong>Test cleanup</strong>)</li>
<li class="fragment">Testovací data (<strong>uživatel s právama</strong>, <strong>prohlížec s načtenou stránkou</strong>, <strong>data v DB</strong>)</li>
<li class="fragment">Dependency injection</li>
</ul>
</section><section id="první-fixture" class="slide level2">
<h2>První fixture</h2>
<div class="sourceCode"><pre class="sourceCode python"><code class="sourceCode python"><span class="im">import</span> pytest

<span class="at">@pytest.fixture</span>
<span class="kw">def</span> structure():
    <span class="kw">class</span> MyStruct(<span class="bu">object</span>):
        text <span class="op">=</span> <span class="st">&quot;text&quot;</span>
        num <span class="op">=</span> <span class="dv">10</span>
    <span class="cf">return</span> MyStruct()

<span class="kw">def</span> test_fix(structure):
    <span class="cf">assert</span> <span class="bu">isinstance</span>(structure.text, <span class="bu">str</span>)
    <span class="cf">assert</span> <span class="bu">isinstance</span>(structure.num, <span class="bu">int</span>)</code></pre></div>
</section><section id="fixture-scope" class="slide level2">
<h2>Fixture scope</h2>
<ul>
<li class="fragment"><p>Scope určuje lifetime fixtury.</p>
<div class="sourceCode"><pre class="sourceCode python"><code class="sourceCode python"><span class="im">import</span> pytest
<span class="at">@pytest.fixture</span>(scope<span class="op">=</span><span class="st">&quot;function&quot;</span>)
<span class="kw">def</span> foo(): <span class="cf">pass</span></code></pre></div></li>
<li class="fragment"><strong>function</strong> - Fixture se vytvoří pri spuštení testu a po skončení se zníčí</li>
<li class="fragment"><strong>module</strong> - Fixture se vytvoří pro jeden python module</li>
<li class="fragment"><p><strong>session</strong> - Fixture se vytvoří pro celý běh testů</p></li>
</ul>
</section><section id="setupcleanup" class="slide level2">
<h2>Setup/Cleanup</h2>
<ul>
<li class="fragment"><p>Pomocí <strong>yield</strong></p>
<div class="sourceCode"><pre class="sourceCode python"><code class="sourceCode python"><span class="im">import</span> sqlite3
<span class="im">import</span> pytest

<span class="at">@pytest.fixture</span>
<span class="kw">def</span> db(request):
    <span class="co"># Setup</span>
    conn <span class="op">=</span> sqlite3.<span class="ex">connect</span>(<span class="st">&#39;:memory:&#39;</span>)

    <span class="cf">yield</span> conn.cursor()

    <span class="co"># Cleanup</span>
    conn.close()


<span class="kw">def</span> test_db(db):
    <span class="cf">assert</span> <span class="bu">isinstance</span>(db, sqlite3.Cursor)</code></pre></div></li>
</ul>
</section><section id="parametrizace-fixture-12" class="slide level2">
<h2>Parametrizace fixture (1/2)</h2>
<div class="sourceCode"><pre class="sourceCode python"><code class="sourceCode python"><span class="im">import</span> pytest

<span class="at">@pytest.fixture</span>(params<span class="op">=</span>[<span class="dv">1</span>, <span class="dv">2</span>, <span class="dv">3</span>, <span class="dv">4</span>])
<span class="kw">def</span> fix_data(request):
    <span class="cf">return</span> request.param


<span class="kw">def</span> division(a, b):
    <span class="cf">return</span> a <span class="op">/</span> <span class="bu">float</span>(b)


<span class="kw">def</span> test_division_param_fix(fix_data):
    <span class="cf">assert</span> division(fix_data, <span class="dv">1</span>) <span class="op">==</span> fix_data</code></pre></div>
</section><section id="parametrizace-fixture-22" class="slide level2">
<h2>Parametrizace fixture (2/2)</h2>
<figure>
<img src="img/param_fix.png" />
</figure>
</section></section>
<section><section id="struktůra-testu" class="titleslide slide level1"><h1>Struktůra testu</h1></section><section id="adresářová-struktůra" class="slide level2">
<h2>Adresářová struktůra</h2>
<pre><code>project_root/
    |_ src/
    |_ tests/ # root testu
        |_ test_unit/ # Unit testy
        |   |_ test_product/
        |        |_ test_product_model.py
        |        |_ ...
        |        |_ conftest.py
        |
        |_ test_integration # Integracni testy
        |   |_ test_product_creation.py
        |   |_ ...
        |
        |_ conftest.py
        </code></pre>
</section><section id="conftest.py-12" class="slide level2">
<h2>conftest.py (1/2)</h2>
<ul>
<li class="fragment">Umožnuje rozšiřovat py.test
<ul>
<li class="fragment">Přidavat argumenty (--url-addr)</li>
<li class="fragment">Hooks atp...</li>
</ul></li>
<li class="fragment">Sdílet fixtury =&gt; fixtura která je definovana v conftest.py je automatický přístupná v testech na stejné nebo zanořené ůrovní.</li>
</ul>
</section><section id="conftest.py-22" class="slide level2">
<h2>conftest.py (2/2)</h2>
<ul>
<li class="fragment">py.test automaticky natahuje všechny <strong>conftest.py</strong> v cestě od rootu testu k danému modulu kde se test nachází
<ul>
<li class="fragment">test_product_model.py
<ul>
<li class="fragment">project_project_root/tests/conftest.py</li>
<li class="fragment">project_root/tests/test_unit/test_product/conftest.py</li>
</ul></li>
</ul></li>
</ul>
</section></section>
<section><section id="reference" class="titleslide slide level1"><h1>Reference</h1></section><section id="pluginy" class="slide level2">
<h2>Pluginy</h2>
<ul>
<li class="fragment"><a href="https://pypi.python.org/pypi/pytest-xdist">pytest-xdist</a> - Paralelizace testů</li>
<li class="fragment"><a href="http://pytest-cov.readthedocs.io/en/latest/readme.html">pytest-cov</a> - Coverage =&gt; Meření pokrytí testy</li>
<li class="fragment"><a href="http://pytest-splinter.readthedocs.io/en/latest/">pytest-splinter</a> - Hight-level API na testování webovek (&quot;nadstavba&quot; nad seleniem, phantomjs)</li>
<li class="fragment"><a href="https://pypi.python.org/pypi/pytest-bdd">pytest-bdd</a> - BDD testovani s podporou Gherkin language</li>
<li class="fragment">Django, sqlalchemy, flask, ...</li>
</ul>
</section><section id="další-zdroje" class="slide level2">
<h2>Další zdroje</h2>
<ul>
<li class="fragment"><a href="https://www.pytest.org">Py.test</a></li>
<li class="fragment"><a href="http://slides.com/jeancruypenynck/introduction-to-pytest/embed">Introduction to pytest</a></li>
<li class="fragment"><a href="http://250bpm.com/blog:40">Unit test fetish</a></li>
<li class="fragment"><a href="https://docs.gitlab.com/ce/ci/environments.html">Gitlab-ci enviroments</a></li>
</ul>
</section></section>
    </div>
  </div>

  <script src="reveal.js/lib/js/head.min.js"></script>
  <script src="reveal.js/js/reveal.js"></script>

  <script>

      // Full list of configuration options available at:
      // https://github.com/hakimel/reveal.js#configuration
      Reveal.initialize({

        // Optional reveal.js plugins
        dependencies: [
          { src: 'reveal.js/lib/js/classList.js', condition: function() { return !document.body.classList; } },
          { src: 'reveal.js/plugin/zoom-js/zoom.js', async: true },
              { src: 'reveal.js/plugin/notes/notes.js', async: true }
        ]
      });
    </script>
    </body>
</html>
